package net.mcreator.skiesofender.entity.renderer;

import net.minecraftforge.fml.client.registry.RenderingRegistry;
import net.minecraftforge.eventbus.api.SubscribeEvent;
import net.minecraftforge.client.event.ModelRegistryEvent;
import net.minecraftforge.api.distmarker.OnlyIn;
import net.minecraftforge.api.distmarker.Dist;

import net.minecraft.util.math.MathHelper;
import net.minecraft.util.ResourceLocation;
import net.minecraft.entity.Entity;
import net.minecraft.client.renderer.model.ModelRenderer;
import net.minecraft.client.renderer.entity.model.EntityModel;
import net.minecraft.client.renderer.entity.MobRenderer;

import net.mcreator.skiesofender.entity.EndempEntity;

import com.mojang.blaze3d.vertex.IVertexBuilder;
import com.mojang.blaze3d.matrix.MatrixStack;

@OnlyIn(Dist.CLIENT)
public class EndempRenderer {
	public static class ModelRegisterHandler {
		@SubscribeEvent
		@OnlyIn(Dist.CLIENT)
		public void registerModels(ModelRegistryEvent event) {
			RenderingRegistry.registerEntityRenderingHandler(EndempEntity.entity, renderManager -> {
				return new MobRenderer(renderManager, new Modelcustom_model(), 0.5f) {
					@Override
					public ResourceLocation getEntityTexture(Entity entity) {
						return new ResourceLocation("skies_of_ender:textures/endemptexture.png");
					}
				};
			});
		}
	}

	// Made with Blockbench
	// Paste this code into your mod.
	// Make sure to generate all required imports
	public static class Modelcustom_model extends EntityModel<Entity> {
		private final ModelRenderer bone;
		private final ModelRenderer bone2;
		private final ModelRenderer bone3;
		private final ModelRenderer bone4;
		private final ModelRenderer bone5;
		private final ModelRenderer bone6;
		private final ModelRenderer bone8;
		private final ModelRenderer bone7;
		public Modelcustom_model() {
			textureWidth = 32;
			textureHeight = 32;
			bone = new ModelRenderer(this);
			bone.setRotationPoint(0.0F, 24.0F, 0.0F);
			addBoxHelper(bone, 0, 0, 1.0F, -4.0F, -1.0F, 1, 4, 3, 0.0F, false);
			bone2 = new ModelRenderer(this);
			bone2.setRotationPoint(0.0F, 24.0F, 0.0F);
			addBoxHelper(bone2, 19, 19, -2.0F, -4.0F, -1.0F, 1, 4, 3, 0.0F, false);
			bone3 = new ModelRenderer(this);
			bone3.setRotationPoint(0.0F, 24.0F, 0.0F);
			addBoxHelper(bone3, 12, 0, -2.0F, -11.0F, -1.0F, 4, 7, 3, 0.0F, false);
			bone4 = new ModelRenderer(this);
			bone4.setRotationPoint(0.0F, 24.0F, 0.0F);
			addBoxHelper(bone4, 0, 11, -3.0F, -16.0F, -2.0F, 6, 5, 5, 0.0F, false);
			addBoxHelper(bone4, 11, 24, -4.0F, -18.0F, 0.0F, 1, 3, 1, 0.0F, false);
			addBoxHelper(bone4, 7, 24, 3.0F, -18.0F, 0.0F, 1, 3, 1, 0.0F, false);
			bone5 = new ModelRenderer(this);
			bone5.setRotationPoint(0.0F, 24.0F, 0.0F);
			addBoxHelper(bone5, 23, 13, -4.0F, -9.0F, 0.0F, 1, 4, 1, 0.0F, false);
			addBoxHelper(bone5, 5, 0, -3.0F, -9.0F, 0.0F, 1, 1, 1, 0.0F, false);
			bone6 = new ModelRenderer(this);
			bone6.setRotationPoint(1.0F, 24.0F, -2.0F);
			setRotationAngle(bone6, -0.2618F, 0.0F, 0.0F);
			addBoxHelper(bone6, 0, 11, 2.0F, -9.4F, 0.0F, 1, 4, 1, 0.0F, false);
			addBoxHelper(bone6, 9, 21, 1.0F, -9.4F, 0.0F, 1, 1, 1, 0.0F, false);
			bone8 = new ModelRenderer(this);
			bone8.setRotationPoint(0.0F, 0.0F, 0.0F);
			setRotationAngle(bone8, -0.2618F, 0.0F, 0.0F);
			bone6.addChild(bone8);
			addBoxHelper(bone8, 0, 0, 2.0F, -5.5F, -4.0F, 1, 1, 10, 0.0F, false);
			addBoxHelper(bone8, 17, 11, 0.0F, -5.5F, -4.7321F, 5, 1, 1, 0.0F, false);
			addBoxHelper(bone8, 11, 21, 0.0F, -5.5F, -6.5981F, 1, 1, 2, 0.0F, false);
			addBoxHelper(bone8, 5, 21, 2.0F, -5.5F, -6.5981F, 1, 1, 2, 0.0F, false);
			addBoxHelper(bone8, 17, 13, 4.0F, -5.5F, -6.5981F, 1, 1, 2, 0.0F, false);
			bone7 = new ModelRenderer(this);
			bone7.setRotationPoint(0.0F, 24.0F, 0.0F);
			addBoxHelper(bone7, 0, 21, -1.0F, -5.0F, 2.0F, 1, 1, 3, 0.0F, false);
			addBoxHelper(bone7, 15, 24, -1.0F, -8.0F, 4.0F, 1, 3, 1, 0.0F, false);
			addBoxHelper(bone7, 0, 7, -2.0F, -9.0F, 4.0F, 3, 1, 1, 0.0F, false);
		}

		@Override
		public void render(MatrixStack ms, IVertexBuilder vb, int i1, int i2, float f1, float f2, float f3, float f4) {
			bone.render(ms, vb, i1, i2, f1, f2, f3, f4);
			bone2.render(ms, vb, i1, i2, f1, f2, f3, f4);
			bone3.render(ms, vb, i1, i2, f1, f2, f3, f4);
			bone4.render(ms, vb, i1, i2, f1, f2, f3, f4);
			bone5.render(ms, vb, i1, i2, f1, f2, f3, f4);
			bone6.render(ms, vb, i1, i2, f1, f2, f3, f4);
			bone7.render(ms, vb, i1, i2, f1, f2, f3, f4);
		}

		public void setRotationAngle(ModelRenderer modelRenderer, float x, float y, float z) {
			modelRenderer.rotateAngleX = x;
			modelRenderer.rotateAngleY = y;
			modelRenderer.rotateAngleZ = z;
		}

		public void setRotationAngles(Entity e, float f, float f1, float f2, float f3, float f4) {
			this.bone2.rotateAngleX = MathHelper.cos(f * 1.0F) * -1.0F * f1;
			this.bone5.rotateAngleX = MathHelper.cos(f * 0.6662F) * f1;
			this.bone4.rotateAngleY = f3 / (180F / (float) Math.PI);
			this.bone4.rotateAngleX = f4 / (180F / (float) Math.PI);
			this.bone.rotateAngleX = MathHelper.cos(f * 1.0F) * 1.0F * f1;
			this.bone6.rotateAngleX = MathHelper.cos(f * 0.6662F + (float) Math.PI) * f1;
		}
	}
	@OnlyIn(Dist.CLIENT)
	public static void addBoxHelper(ModelRenderer renderer, int texU, int texV, float x, float y, float z, int dx, int dy, int dz, float delta) {
		addBoxHelper(renderer, texU, texV, x, y, z, dx, dy, dz, delta, renderer.mirror);
	}

	@OnlyIn(Dist.CLIENT)
	public static void addBoxHelper(ModelRenderer renderer, int texU, int texV, float x, float y, float z, int dx, int dy, int dz, float delta,
			boolean mirror) {
		renderer.mirror = mirror;
		renderer.addBox("", x, y, z, dx, dy, dz, delta, texU, texV);
	}
}
