
package net.mcreator.skiesofender.item;

import net.minecraftforge.registries.ObjectHolder;

import net.minecraft.item.crafting.Ingredient;
import net.minecraft.item.SwordItem;
import net.minecraft.item.Items;
import net.minecraft.item.ItemStack;
import net.minecraft.item.ItemGroup;
import net.minecraft.item.Item;
import net.minecraft.item.IItemTier;

import net.mcreator.skiesofender.SkiesOfEnderModElements;

@SkiesOfEnderModElements.ModElement.Tag
public class PitchforkItem extends SkiesOfEnderModElements.ModElement {
	@ObjectHolder("skies_of_ender:pitchfork")
	public static final Item block = null;
	public PitchforkItem(SkiesOfEnderModElements instance) {
		super(instance, 33);
	}

	@Override
	public void initElements() {
		elements.items.add(() -> new SwordItem(new IItemTier() {
			public int getMaxUses() {
				return 100;
			}

			public float getEfficiency() {
				return 4f;
			}

			public float getAttackDamage() {
				return 7f;
			}

			public int getHarvestLevel() {
				return 0;
			}

			public int getEnchantability() {
				return 8;
			}

			public Ingredient getRepairMaterial() {
				return Ingredient.fromStacks(new ItemStack(Items.ENDER_PEARL, (int) (1)));
			}
		}, 3, -1.5f, new Item.Properties().group(ItemGroup.COMBAT)) {
		}.setRegistryName("pitchfork"));
	}
}
