
package net.mcreator.skiesofender.item;

import net.minecraftforge.registries.ObjectHolder;

import net.minecraft.item.UseAction;
import net.minecraft.item.Rarity;
import net.minecraft.item.ItemStack;
import net.minecraft.item.ItemGroup;
import net.minecraft.item.Item;
import net.minecraft.item.Food;

import net.mcreator.skiesofender.SkiesOfEnderModElements;

@SkiesOfEnderModElements.ModElement.Tag
public class LumaberryItem extends SkiesOfEnderModElements.ModElement {
	@ObjectHolder("skies_of_ender:lumaberry")
	public static final Item block = null;
	public LumaberryItem(SkiesOfEnderModElements instance) {
		super(instance, 16);
	}

	@Override
	public void initElements() {
		elements.items.add(() -> new FoodItemCustom());
	}
	public static class FoodItemCustom extends Item {
		public FoodItemCustom() {
			super(new Item.Properties().group(ItemGroup.FOOD).maxStackSize(64).rarity(Rarity.COMMON)
					.food((new Food.Builder()).hunger(5).saturation(4.8f).build()));
			setRegistryName("lumaberry");
		}

		@Override
		public UseAction getUseAction(ItemStack itemstack) {
			return UseAction.EAT;
		}
	}
}
